/*
 * 20200722_m328_oled_cpp.cpp
 *
 * Created: 2020-07-22 09:24:48
 * Author : uwezi
 */ 

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include "SSD1306_I2C.h"
#include "DigiFont.h"

// needed for DigiFont library initialization, define your customLineH, customLineV and customRect
void customLineH(int x0,int x1, int y, int c) { DISPLAY_hLine(x0,x1,y,c); }
void customLineV(int x, int y0,int y1, int c) { DISPLAY_vLine(x,y0,y1,c); }
void customRect(int x, int y,int w,int h, int c) { DISPLAY_Rect(x,y,w,h,c); }
DigiFont font(customLineH,customLineV,customRect);

void demoCounter(uint8_t sx, uint8_t sy, uint8_t t)
{
  uint16_t j;
  DISPLAY_clearbuffer();
  font.setColors(1,0);
  int w=DISPLAYSIZEX/12;

  for (j=0; j<1; j++)
  {
    font.setSize1(sx,sy,t);
    for(int i=0;i<10;i++) font.drawDigit1((j+i)%10,2+i*(sx+2),5);
    DISPLAY_update();
    _delay_ms(400);
  }
}

int main (void)
{
  uint16_t i=0, sx=5, t=1;
  char buffer[20];
  DISPLAY_init();
  font.setColors(1,0);
  DDRB ^= (1 << PB0);
  while (1)
  {
    demoCounter(sx, 2*sx, t);
    t++;
    if (2*t > sx)
    {
      t=1;
      sx++;
      if (sx>15)
      {
        sx=5;
      }
    }
  }
  return 0;
}

